# XIOT - The X3D I/O Toolkit library 

[![Build Status](https://travis-ci.org/Supporting/xiot.svg?branch=master)](https://travis-ci.org/Supporting/xiot)
[![Build status](https://ci.appveyor.com/api/projects/status/tiy0r1f9dmpte1tq/branch/master?svg=true)](https://ci.appveyor.com/project/Supporting/xiot/branch/master)

## About

This library provides an open source generic C++ toolkit to import and
export X3D in its differents XML encodings : ASCII and binary. A special
development was done to provide a FI (FastInfoset) based X3D encoding.

See project homepage for more details:
http://forge.collaviz.org/community/xiot
	
## Credits

This project was lead by Actor3D and funded by EDF R&D in the context of 
the COLLAVIZ project with the financial support of the French National 
Research Agency (ANR-08-COSI-003)

See also:
* http://www.actor3d.com
* http://research.edf.com
* http://www.collaviz.org/

## License terms

This library is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the
Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version.

This library is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License
for more details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, write to the Free Software Foundation,
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

See the COPYING file for details.
	
## Package directory layout
```
   /doc
     /html              :  API HTML documentation.
   /examples            :  Example programs: VTK based X3D viewer
   /contrib             :  3rd party libraries (windows only)
   /data                :  Example X3D files
   /plugins             :  ParaView plugin example
   /src                 :  Library source
     /gen			    :  Source generation
   /tests               :  Test programs
```
   
## Prerequisites

XIOT requires XercesC or Expat XML parser and zlib compression library to
build. You can choose your favourite XML parser using the
`XML_PARSER_SELECTION` option for CMake.
	
### XercesC
The Apache XML parser library is contained in the contrib directory for
win32 and win64 build with VC9. On Linux system, XercecC can easily be 
obtained using the package system, i.e. via:

	sudo apt-get install libxerces27 libxerces27-dev

If not, consult the following URI to get binaries or the source for 
XercesC: http://xerces.apache.org/xerces-c/

The library has been tested with Xerces versions 2.7.0 and 3.0.0.

### Expat

The Expat XML parser library is contained in the contrib directory for win32 build with VC9. On Linux system, Expat can easily be 
obtained using the package system, i.e. via:

	sudo apt-get install libexpat1 libexpat-dev

If not, consult the following URI to get binaries or the source for Expat: http://expat.sourceforge.net/

The library has been tested with Expat version 2.0.1

### zlib

The zlib compression library is packaged with many systems. Static builds for win32/64 build with VC are contained in the contrib directory. On Linux systems, zlib can easily be obtained using the package system, i.e. via:

	sudo apt-get install zlib1g zlib1g-dev

If not, consult the following URI to get binaries or the source for zlib: http://www.zlib.net/

The library has been tested with zlib version 1.2.3.

For additional prerequisites for the example viewer and for the ParaView plugin please refer to the README files in subdirectories example and plugins.

## Installation

Refer to the file "INSTALL" for detailed installation instructions.
	
	
